/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021 MAYO
 * BMP180 _OLED
*/

//___________OLED_________
#include "olex.h"
#include <Wire.h>


#define BMP180_ADDR 0x77 // 7-bit address

#define	BMP180_REG_CONTROL 0xF4
#define	BMP180_REG_RESULT 0xF6
#define	BMP180_COMMAND_TEMPERATURE 0x2E

int AC1,AC2,AC3,VB1,VB2,MB,MC,MD;
unsigned int AC4,AC5,AC6; 
unsigned char _error;

long Temperatura,Presion,PresionBase;
unsigned char mibufferU[10];
char mibuffer[20];


// altura en Palencia
#define ALTURA 790

char L1_presion[25];
char L2_presion[25];
char L3_presion[25];

void printPresion(void)
{
  xStringAT(0,1,L1_presion);  Serial.println(L1_presion);
  xStringAT(0,2,L2_presion);  Serial.println(L2_presion);
  xStringAT(0,3,L3_presion);  Serial.println(L3_presion); Serial.println();
}

char VARI[100];
char TITULO[]="--  BMP180  --";

void setup()
{ 
    Serial.begin(9600);  

    OleInit();
    xclearDisplay(); 
    ModeFont=0; xStringAT(0,0,TITULO);

    startBMP180();
    getBMP180();
    PresionBase=Presion;   
    Serial.print("Presion base: ");
    Serial.print(PresionBase);
    Serial.println(" mb");  
}

void loop()
{
  int z;

  if(getBMP180()){  Serial.print("ERRORES=");  Serial.println(_error);}
    
  intTOstring(Temperatura,5,2);  
  sprintf(L1_presion,"T: %s C",mibuffer);  
  
  z=Presion/100;
  intTOstring(z,5,0); 
  sprintf(L2_presion,"P: %s mb",mibuffer);   
 
  z=DifAltitud(Presion,PresionBase);
  intTOstring(z,5,2); 
  sprintf(L3_presion,"L: %s metros",mibuffer);  

  printPresion();
 
  delay(2000);
}



int DifAltitud(long Pres,long PresBase)
{
 long z,zz;
   
   z=PresBase-Pres;
   z*=904;
   z/=100;     
   return((int)z);  
}


/*
double altitude(double P, double P0)
{
	return(44330.0*(1-pow(P/P0,1/5.255)));
}
*/


//_SETA43_____

int MiLecturaI(char address)
{
  char x;
  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(address);
  if(Wire.endTransmission()) Serial.print("ERROR ");
  
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++)  mibufferU[x] = Wire.read();
  return( (((int)mibufferU[0]<<8)|(int)mibufferU[1]) ); 
}  


char startBMP180(void)
{
  Wire.begin();      
  AC1=MiLecturaI(0xAA);
  AC2=MiLecturaI(0xAC);
  AC3=MiLecturaI(0xAE);
  AC4=MiLecturaI(0xb0);
  AC5=MiLecturaI(0xb2);
  AC6=MiLecturaI(0xb4);
  VB1=MiLecturaI(0xb6);
  VB2=MiLecturaI(0xb8);
  MB=MiLecturaI(0xba);
  MC=MiLecturaI(0xbc);
  MD=MiLecturaI(0xbe);
}


char getBMP180(void)
{
  char x;
  long x1,x2,x3,mtu,mpu,b5,b6,b3,p;
  unsigned long b4,b7;
  
  _error=0;
   
  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = BMP180_COMMAND_TEMPERATURE;  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(20);
  
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++) mibufferU[x] = Wire.read();
  mtu = mibufferU[0];
  mtu=mtu<<8;
  mtu+=mibufferU[1];  //UT
 Serial.print("mtu=");Serial.print(mtu);

  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = 0x34;  //oss=0
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(26);
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,3);
  while(Wire.available() != 3) ; 
  for(x=0;x<3;x++) mibufferU[x] = Wire.read();  
 // for(x=0;x<3;x++) Serial.println(mibufferU[x]);  
  mpu = mibufferU[0];
  mpu=mpu<<16;
  x1=mibufferU[1];
  x1=x1<<8;
  mpu+=x1;
  mpu+=mibufferU[1];
  mpu=mpu>>8;  //oss=0    UP
  Serial.print("   mpu=");Serial.println(mpu);
     
  x1=mtu-AC6;  x1*=AC5;  x1=x1>>15;
  x2=MC;  x2=x2<<11;  x2/=(x1+MD);
  x1+=x2;
  b5=x1;
  x1+=8;
  x1*=10;
  Temperatura=x1>>4;
  

  b6=b5-4000;
  x1=b6*b6;  x1=x1>>12;  x1=x1*VB2;  x1=x1>>11;
  x2=AC2;  x2=x2*b6; x2=x2>>11;
  x3=x2+x1;
  b3=AC1; b3=b3<<2; b3=b3+x3; b3=b3+2; b3=b3>>2;
  x1=AC3; x1*=b6;  x1=x1>>13;
  x2=b6*b6; x2=x2>>12; x2=x2*VB1; x2=x2>>16;
  x3=x1+x2;  x3=x3+2; x3=x3>>2;
  b4=x3;  b4=b4+32768;  b4=b4*AC4;  b4=b4>>15;
  b7=mpu-b3;  b7=b7*50000;
  if(b7<0x80000000)
    {
      p=b7; p=p<<1; p=p/b4;
    }
    else
    {
      p=b7/b4;  p=p<<1;
    }
  x1=p;  x1=x1>>8;  x1=x1*x1;
  x1=x1*3038;  x1=x1>>16;
  x2=-7357;  x2*=p;  x2=x2>>16;
  x1+=x2;  x1=x1+3791; x1=x1>>4;  p+=x1; 
  Presion=p;
  
return(_error); 	
}


//_SETA43__
void intTOstring(int n,unsigned char dig,unsigned char dec)
{
	int z,x,zz;
	char signo;

	zz=0;
	z=10000;
	if(n<0)	{ signo='-'; n*=-1;}	else	{signo='+';	}
	mibuffer[zz]=signo;	zz++;
	for(;z>0;z=z/10)
	{
		x=n/z;
		n=n-(z*x);
		mibuffer[zz]=x+'0';
		zz++;
	}
	mibuffer[zz]=0;
	
	if(dec!=0)
	 {
		x=zz+1;
		for(;zz>=0;zz--)
		{
		mibuffer[x]=mibuffer[zz];
		x--;
		if(0==dec) { mibuffer[x]='.'; x--;}	
		dec--;
		}
	 }
}
